.TH relax 1 
.ds ]W relax (5/94)
.SH NAME
\fBrelax \(em HTML editor\fP
.sp 1
.SH SYNOPSIS
.B relax
.sp 1
.SH DESCRIPTION
\fBrelax\fP is an editor that supports the creation of documents for the
\fBWWW\fP (World Wide Web) in the HTML markup language. Since knowing and 
editing HTML tags using an ordinary text editor tends to be a hard job, this 
application is supposed to provide an easier way of writing HTML documents.
.P
The HTML editor \fBrelax\fP was developed with the Motif1.2 Toolkit.
So it shows the typical Motif look when run on the X Window System.
The application is intended to be controlled by a mouse pointer as well as
by keyboard input.
.sp 1
.SH MAIN WINDOWS
.SS Editing Window
This window shows up when \fBrelax\fP is first executed. Its components
are:
.TP 4
.BI  "Name Label"
On the very top of the Editing Window is the name of the editor.
.TP 4
.BI  "File Label"
Below the name label appears the path of the currently edited
file. If the document has not been saved it is labelled "*unknown*".
.TP 4
.BI  "Menu Bar"
The menu bar offers various buttons for editing and manipulating the
text. These may either be selected by clicking on their item names or
by pressing the underscored character (mnemonic) while holding down the
[ALT] key. By activating the desired button a pulldown menu of
its related functions pops up. The latter also have mnemonics to
be pressed. Some show "accelerators" (e.g. Load: CTRL+L) that
provide a quick way of directly choosing a function while editing
the document.
.TP 4
.BI  "Text Field"
This is the area where the actual ASCII text (including HTML tags) is 
typed in. Horizontal and vertical scrollbars may move larger documents.
.TP 4
.BI  "Buttons Bar"
Frequently needed buttons are placed on the bottom of the window .
.SS Parsed Text Window
The "Parse" button in the menu and buttons bar executes a function that
displays the edited ASCII text in Mosaic style and puts it into a 
separate window.
.TP 4
.BI  "Name Label"
This is only the label of the Parsed Text Window.
.TP 4
.BI  "Document Title"
Usually a title is specified in an HTML document. If this is the case, 
it is revealed in the Parsed Text Window. Otherwise this label shows
"*NO TITLE*".
.TP 4
.BI  "Parsed Text Field"
As opposed to the Editing Window the Parsed Text Window shows the
same text that is being edited in a Mosaic formatted style.
Please note: Images with a reference in the ASCII text are not 
displayed as actual pictures but they are substituted by the default
Mosaic logo.
.TP 4
.BI  "Cancel Button"
This button removes the Parsed Text Window.
.sp 1
.SH MENU ITEMS
.SS File
This menu item contains the following options: "New", "Load", "Save", 
"Save As", "Quit". When "Load" or "Save" is selected, a file selection box
appears that allows the user to choose a file. The functions "New", "Load"
and "Quit" check for unsaved changes before removing the document and
pop up a warning message if necessary.
.SS Edit
Besides the commonly known operations "Cut", "Copy", "Paste", "Undo" and
"Delete", Edit provides a "Parse" option which sets up the Parsed Text Window
with the formatted ASCII Text (see above).
.PP
The following menu items contain buttons for inserting various HTML tags
into the document. If an area of the text was selected, the chosen HTML tags
wrap the selection up between the starting tag and the ending tag; otherwise
only the starting tag and the ending tag appear at the cursor position and
the cursor is placed right between them. 
(For a complete description of HTML tags see 
.B On HTML...
in the on-line help of the 
.B Mosaic
program)
.SS Text
Text provides tags for different text styles like "Bold", "Italics", etc.
The title of the document may be entered using "Title". "Special Chars" pops
up a list of special characters that can be inserted in the ASCII text.
.SS Headlines
All six Mosaic header levels ("H1", "H2", .., "H6") are found in this menu.
"H1" represents the biggest header, "H6" the smallest header.
.SS Block
Functions under Block mainly deal with larger sections of the text. Some
examples are "Paragraph", "Blockquote", "Listing", etc. The "Paragraph" tag
is needed to indicate the end of any paragraph in the document, since
line breaks, multiple spaces and indentations are ignored by HTML browsers
(except the text is a "Listing" or is "Preformatted").
A "Horizontal Ruler" is used to separate different parts of the document.
.SS Lists
Here the user may choose to fill in an "Unnumbered", "Numbered" or "Descriptive"
list form. The "Add <LI>" and "Add <DT>" buttons allow the addition of further 
list items to an already existing list.
.SS Links
"Set Name" and "Link To Name" are used to create a name and to make a reference 
to a name in the same document. References to other documents and to images can 
be set by executing "Link To File" and "Link To Image" respectively. These
functions pop up a dialog window where frequently accessed anchors (or images)
may be added to or deleted from history lists that are read in when the 
editor is started. As selected in the dialog window images are aligned to the
bottom or to the top of the line on which they appear.
.sp 1
.SH FILES
.IP "relax" 3.0i
relax executable
.IP "Relax"
application defaults file; this file should be moved to 
/usr/lib/X11/app-defaults/Relax or $HOME/Relax
.IP "$HOME/.relax_image_hist"
history file for images (created on first execution)
.IP "$HOME/.relax_link_hist"
history file for links (created on first execution)
.IP "relax.1"
manual page to be put in the appropriate place, e.g. /usr/man/man1/relax.1
.IP "relax.c"
main source file
.IP "relax_procs_file.c"
functions of the File menu
.IP "relax_procs_edit.c" 
functions of the Edit menu
.IP "relax_procs_tags.c"
functions of the Text, Headlines and Block menu
.IP "relax_procs_link.c"
functions of the Link menu
.IP "relax_global-defines.h"
defines for all source files
.IP "relax_menu-specs.h"
menu specifications
.IP "relax_widget-stuff.h"
Motif 1.2 include files
.sp 1
.SH BUGS
When starting \fBrelax\fP the following warning message is printed:
.br
Warning: Actions not found: process-return, delete-previous-character, ...
.br
Probably this message is caused by translations that are bound to the "Scrolled
Text Widget" but are not accepted by one of its parents. Simple as the 
solution might be we have not yet found a way to fix the problem. However,
this does not trouble the performance or stability of the program at all.
.PP
Some very strange behaviour appears while running \fBrelax\fP under the Motif 
Window Manager \fBmwm\fP. Choosing any button from the menu bar results in 
the ASCII Text Field losing its input focus so that it becomes impossible
to enter any more text. In that case, just select another menu item (without
activating a function) and you will get your keyboard focus back.
.sp 1
.SH NOTES
.B relax
is partly based on the NCSA
.B Mosaic
software.
NCSA
.B Mosaic
software, both binary and source (hereafter, Software) is
copyrighted by The Board of Trustees of the University of Illinois
(UI), and ownership remains with the UI.
.PP
The editor
.B relax
uses the 'htmlWidgetClass' and the 'HTMLSetText' 
procedure of the 'HTML.h' include file for parsing the edited text 
into a Mosaic formatted style. Moreover, 'HTMLamp.h' is included for
the special character popup. 
.PP
Certainly,
.B relax
is not the original NCSA
.B Mosaic
but uses some of its Software for such derivative work.
.sp 1
.SH COPYRIGHT
.B relax
is Copyright (C) 1994, Department of Computer Science at the TUM
(Munich University of Technology), Germany.
.PP
NCSA
.B Mosaic
is Copyright (C) 1993, Board of Trustees of the University of Illinois.
.sp 1
.SH AUTHORS
.IP "Bernhard Blaette" 3.0i
blaetteb@informatik.tu-muenchen.de
.IP "Michael Tiefenbacher"
tiefenba@informatik.tu-muenchen.de
.sp 1
.SH SEE ALSO
\fBxmosaic(1)\fP
