/*	
 *	relax - an editor for creating HTML documents
 *	
 *	Copyright (C) 1994 by the Department of Computer Science at the TUM
 *	(Munich University of Technology, Germany)
 *	
 *	Authors: Bernhard Blaette, Michael Tiefenbacher
 *	
 *	This program is partly based on the NCSA Mosaic software.
 *	NCSA Mosaic software, both binary and source (hereafter, Software) is
 *	copyrighted by The Board of Trustees of the University of Illinois
 *	(UI), and ownership remains with the UI.
 *	The editor "relax" uses the 'htmlWidgetClass' and the 'HTMLSetText' 
 *	procedure of the 'HTML.h' include file for parsing the edited text 
 *	into a Mosaic formatted style. Moreover, 'HTMLamp.h' is included for
 *	the special character popup. 
 *	Certainly, "relax" is not the original NCSA Mosaic but uses some of
 *	its Software for such derivative work.
 *	
 *	Permission to use, copy, modify, and distribute this software and its 
 *	documentation for any purpose and without fee is hereby granted,
 *	provided that this comment and the authors' names are retained and
 *	appear in all copies and that both that copyright notice and this 
 *	permission notice appear in supporting documentation.
 *	
 *	This software is provided 'as is' without express or implied warranty.
 *	In no event shall the authors or the TUM be liable for errors contained 
 *	in the software, or for direct, indirect, special, incidental or 
 *	consequential damages with the use of the software.
 *	
 */

#ifndef GLOBAL_H
#define GLOBAL_H


/*----------------------------------------------------------------------------*/

#define _NO_PROTO

/*----------------------------------------------------------------------------*/

/* relax.c */
extern	Widget 	W_ScrolledText;
extern	Widget 	W_FileLabel;
extern	Widget 	W_AddLi;
extern	Widget 	W_AddDt;
extern	Widget 	W_ButtonPaste;
extern	Widget 	W_MenuPaste;
extern	Widget 	W_MainWindow;
extern	Widget 	W_MenuBar;
extern	Widget 	W_ButtonForm;
extern	char*	HomeDir;
extern	char*	FileNameImageHist;
extern	char*	FileNameLinkHist;

/* relax_procs_file.c */
extern	char 	NullChar;
extern	char*  	CheckBuffer;
extern	char* 	HTMLHeader;
extern	char* 	HTMLFooter;

/* relax_procs_link.c */
extern	Widget	W_AliDialog;
extern	Cardinal Link_Counter;
extern	Cardinal Image_Counter;
extern	XmString Link_List[200];
extern	XmString Image_List[200];


/*----------------------------------------------------------------------------*/

/* relax_procs_edit.c */
extern	void	ScrolledTextSetSensitive();
extern	void 	EnableUndo();

/* relax_procs_file.c */
extern	Bool	FileInfo();
extern	char* 	ReadFile();
extern	void	SaveLists();
extern	void 	LoadLists();

/* relax_procs_tags.c */
extern	void 	InsertText();
extern	void 	InsertTags();


/*----------------------------------------------------------------------------*/


#endif /* GLOBAL_H */
