/*	
 *	relax - an editor for creating HTML documents
 *	
 *	Copyright (C) 1994 by the Department of Computer Science at the TUM
 *	(Munich University of Technology, Germany)
 *	
 *	Authors: Bernhard Blaette, Michael Tiefenbacher
 *	
 *	This program is partly based on the NCSA Mosaic software.
 *	NCSA Mosaic software, both binary and source (hereafter, Software) is
 *	copyrighted by The Board of Trustees of the University of Illinois
 *	(UI), and ownership remains with the UI.
 *	The editor "relax" uses the 'htmlWidgetClass' and the 'HTMLSetText' 
 *	procedure of the 'HTML.h' include file for parsing the edited text 
 *	into a Mosaic formatted style. Moreover, 'HTMLamp.h' is included for
 *	the special character popup. 
 *	Certainly, "relax" is not the original NCSA Mosaic but uses some of
 *	its Software for such derivative work.
 *	
 *	Permission to use, copy, modify, and distribute this software and its 
 *	documentation for any purpose and without fee is hereby granted,
 *	provided that this comment and the authors' names are retained and
 *	appear in all copies and that both that copyright notice and this 
 *	permission notice appear in supporting documentation.
 *	
 *	This software is provided 'as is' without express or implied warranty.
 *	In no event shall the authors or the TUM be liable for errors contained 
 *	in the software, or for direct, indirect, special, incidental or 
 *	consequential damages with the use of the software.
 *	
 */
#include <stdio.h>

#include <relax_widget-stuff.h>
#include <relax_global-defines.h>

#include <HTMLamp.h>
/*----------------------------------------------------------------------------*/


/*----------------------------------------------------------------------------*/
/*Special Characters*/
/*----------------------------------------------------------------------------*/

void
AmpCodeInsert(code)
char code;
{
	int i=0, len;
      	Arg  args[10];
	XmTextPosition cursorPos;
	char  ampstr[20];
	char* amptag;

	while ( (AmpEscapes[i].tag != NULL) &&
		(code != AmpEscapes[i].value) )
	{	i++;
	}
	if (AmpEscapes[i].tag != NULL)
	{	amptag = AmpEscapes[i].tag;
		len = strlen(amptag);

		ampstr[0] = '&';
		for(i=0;i<=len;i++)
			ampstr[i+1] = amptag[i];
		ampstr[len+1] = ';';
		ampstr[len+2] = '\0';

    		XtSetArg(args[0], XmNcursorPosition, &cursorPos);
   		XtGetValues(W_ScrolledText, args, 1);
	 	XmTextReplace(W_ScrolledText, cursorPos, cursorPos, ampstr);

		cursorPos += (len+2);
    		XtSetArg(args[0], XmNcursorPosition, cursorPos);
   		XtSetValues(W_ScrolledText, args, 1);

		ScrolledTextSetSensitive();
	}		
}

void	
Menu_ButtonCharSel(widget, client_data, call_data)
Widget	widget;		
XtPointer client_data, call_data;
{
	char button = *((char*) client_data);

	EnableUndo();

	AmpCodeInsert(button);
}


void 
CharSelOk_CB(widget, client_data, call_data)
Widget	widget;		
XtPointer client_data, call_data;
{
	Widget ok, dialog, dialogtext;
	char* buttonname;

	ok = (Widget) widget;
	dialogtext = (Widget) client_data;
	dialog = XtParent(XtParent(XtParent(ok)));

	EnableUndo();

	buttonname = XmTextFieldGetString(dialogtext);

	AmpCodeInsert(buttonname[0]);

	XtDestroyWidget(dialog);
	XtFree(buttonname);
}

void 
CharSelCancel_CB(widget, client_data, call_data)
Widget	widget;		
XtPointer client_data, call_data;
{	
	Widget cancel, dialog;

	cancel = (Widget) widget;
	dialog = XtParent(XtParent(XtParent(cancel)));

	XtDestroyWidget(dialog);
}

void 
Menu_CharSelDialog(widget, client_data, call_data)
Widget	widget;		
XtPointer client_data, call_data;
{	
      	Arg  args[10];
     	int  n, c, cc; 
     	Widget  Charseldialog, help, apply, ok, cancel, dialogtext;
	Widget  dialogShell, frame;
	char* item="\0";

       	XmString cstring_list_items[200];

       	c = 0; cc = 0;
	while (AmpEscapes[c].tag != NULL)
	{	if (*item == AmpEscapes[c].value)
			c++;
		else
		{
			item = &AmpEscapes[c].value;
        		cstring_list_items[cc] = XmStringCreateSimple(item);
			c++; cc++;
		}
	}

     	n = 0;
 	dialogShell = XmCreateDialogShell(widget, "CharSelDialog", args, n);

  	n = 0;
     	XtSetArg(args[n], XmNwidth, 200); n++;
     	XtSetArg(args[n], XmNheight, 350); n++;

 	frame = XmCreateFrame(dialogShell, "frame", args, n);

     	n = 0;
     	XtSetArg(args[n], XmNlistItems, cstring_list_items); n++;
     	XtSetArg(args[n], XmNlistItemCount, cc); n++;
     	XtSetArg(args[n], XmNwidth, 200); n++;
     	XtSetArg(args[n], XmNheight, 350); n++;

    	Charseldialog = XmCreateSelectionBox (
		frame, "CharSelDialog-Box", args, n);

	help = XmSelectionBoxGetChild(
	    Charseldialog, XmDIALOG_HELP_BUTTON);
	apply = XmSelectionBoxGetChild(
	    Charseldialog, XmDIALOG_APPLY_BUTTON);
	ok = XmFileSelectionBoxGetChild(
	    Charseldialog, XmDIALOG_OK_BUTTON);
	cancel = XmFileSelectionBoxGetChild(
	    Charseldialog, XmDIALOG_CANCEL_BUTTON);
	dialogtext = XmFileSelectionBoxGetChild(
	    Charseldialog, XmDIALOG_TEXT);
	XtUnmanageChild(help);
	XtUnmanageChild(apply);

	XtAddCallback(ok, XmNactivateCallback, CharSelOk_CB, 
		(XtPointer) dialogtext);
	XtAddCallback(cancel, XmNactivateCallback, CharSelCancel_CB, NULL);

     	XtManageChild (Charseldialog);
   	XtManageChild (frame);
}

/*----------------------------------------------------------------------*/
/*Insert Text in Scrolled Text  (Buffer1)  */
/*----------------------------------------------------------------------*/	

void 
InsertText(buffer)
char	*buffer;
{
	int		length; 
  	XmTextPosition 	CursorPos, NewCursorPos;
   	Arg            	args[10];             
 	
	EnableUndo();
	
	/*Getting length of Text  */
	length = strlen (buffer);

	/* Get cursor position for pasting */
   	XtSetArg(args[0], XmNcursorPosition, &CursorPos);
   	XtGetValues(W_ScrolledText, args, 1);
      
	/* Add new text and set cursor*/
   	XmTextInsert(W_ScrolledText, CursorPos, buffer);

	NewCursorPos = CursorPos + length;
 	XtSetArg(args[0], XmNcursorPosition, NewCursorPos);
   	XtSetValues(W_ScrolledText, args, 1);
}               

/*----------------------------------------------------------------------*/
/*Insert Tags in Scrolled Text  (Buffer1, Buffer2 werden uebergeben)  */
/*----------------------------------------------------------------------*/	

void 
InsertTags(buffer1, buffer2)
char	*buffer1;               
char    *buffer2;
{  	
	char		*selected_string = XmTextGetSelection (W_ScrolledText);
	int		lengthl, lengthr;	   
   	XmTextPosition 	CursorPos, NewCursorPos, LeftCursorPos, RightCursorPos;
   	register int   	n;                     
   	Arg            	args[10];             

	EnableUndo();

/*Lenght of tags  */
	lengthl = strlen (buffer1);
	lengthr = strlen (buffer2);

/*Insert tags (no text marked)  */
   	if (selected_string == NULL) 
	{
		/* Get cursor position for pasting */
   		XtSetArg(args[0], XmNcursorPosition, &CursorPos);
   		XtGetValues(W_ScrolledText, args, 1);
      
		/* Add new text and set cursor*/
   		XmTextReplace(W_ScrolledText, CursorPos, CursorPos, buffer2);
   		XmTextReplace(W_ScrolledText, CursorPos, CursorPos, buffer1);
		
		NewCursorPos = CursorPos + lengthl;
  		XtSetArg(args[0], XmNcursorPosition, NewCursorPos);
   		XtSetValues(W_ScrolledText, args, 1);

	}
/*Insert tags (text marked)  */
	else
	{
		XmTextGetSelectionPosition(
			W_ScrolledText, &LeftCursorPos, &RightCursorPos);

     		
     		XmTextInsert(W_ScrolledText, RightCursorPos, buffer2);
    		XmTextInsert(W_ScrolledText, LeftCursorPos, buffer1);

		NewCursorPos = RightCursorPos + lengthl + lengthr;
  		XtSetArg(args[0], XmNcursorPosition, NewCursorPos);
   		XtSetValues(W_ScrolledText, args, 1);
	}
	XtFree(selected_string);
	ScrolledTextSetSensitive();
}

/*----------------------------------------------------------------------*/
/*Text Tags  */
/*----------------------------------------------------------------------*/

void 
Menu_Tags(widget, client_data, call_data)
Widget	widget;		
XtPointer client_data, call_data;
{
  	char		*buffer1;               
 	char         	*buffer2;

/*Text  */	
    	if (strcmp("Title", (char*)client_data)==0)
		{
			buffer1 = "<Title>";
		  	buffer2 = "</Title>";
		}
	else if (strcmp("Bold", (char*)client_data)==0)
		{
		  	buffer1 = "<B>";
		  	buffer2 = "</B>";
		}
	else if (strcmp("Emphasized", (char*)client_data)==0)
		{
		  	buffer1 = "<EM>";
		  	buffer2 = "</EM>";
		}
	else if	(strcmp("Strong", (char*)client_data)==0)
		{
			buffer1 = "<Strong>";
		  	buffer2 = "</Strong>";
		}
	else if (strcmp("Italics", (char*)client_data)==0)
		{
			buffer1 = "<I>";
		  	buffer2 = "</I>";
		}
	else if	(strcmp("Citation", (char*)client_data)==0)
		{
			buffer1 = "<Cite>";
		  	buffer2 = "</Cite>";
		}	
	else if	(strcmp("Typewriter", (char*)client_data)==0)
		{
			buffer1 = "<TT>";
		  	buffer2 = "</TT>";
		}	
	else if	(strcmp("Code", (char*)client_data)==0)
		{
			buffer1 = "<Code>";
		  	buffer2 = "</Code>";
		}	
	else if	(strcmp("Sample", (char*)client_data)==0)
		{
			buffer1 = "<Samp>";
		  	buffer2 = "</Samp>";
		}	
	else if	(strcmp("Keyboard", (char*)client_data)==0)
		{
			buffer1 = "<Kbd>";
		  	buffer2 = "</Kbd>";
		}	
	else if	(strcmp("Variable", (char*)client_data)==0)
		{
			buffer1 = "<Var>";
		  	buffer2 = "</Var>";
		}
	else if	(strcmp("Comment", (char*)client_data)==0)
		{
			buffer1 = "<!-- ";
		  	buffer2 = " >";
		}
	
/* Headline types */
	else if	(strcmp("Type H1", (char*)client_data)==0)
		{
			buffer1 = "<H1>";
		  	buffer2 = "</H1>";
		}	
	else if	(strcmp("Type H2", (char*)client_data)==0)
		{
			buffer1 = "<H2>";
		  	buffer2 = "</H2>";
		}	
	else if	(strcmp("Type H3", (char*)client_data)==0)
		{
			buffer1 = "<H3>";
		  	buffer2 = "</H3>";
		}	
	else if	(strcmp("Type H4", (char*)client_data)==0)
		{
			buffer1 = "<H4>";
		  	buffer2 = "</H4>";
		}	
	else if	(strcmp("Type H5", (char*)client_data)==0)
		{
			buffer1 = "<H5>";
		  	buffer2 = "</H5>";
		}	
	else if	(strcmp("Type H6", (char*)client_data)==0)
		{
			buffer1 = "<H6>";
		  	buffer2 = "</H6>";
		}	
/* List tags */  		
	else if	(strcmp("Unnumbered", (char*)client_data)==0)
		{
			buffer1 = "<UL>\n<LI>\t";
		  	buffer2 = "\n</UL>";
		}
	else if	(strcmp("Numbered", (char*)client_data)==0)
		{
			buffer1 = "<OL>\n<LI>\t";
		  	buffer2 = "\n</OL>";
		}
	else if	(strcmp("Descriptive", (char*)client_data)==0)
		{
			buffer1 = "<DL>\n<DT>\t";
		  	buffer2 = "\n\t<DD>\t\n</DL>";
		}
	else if	(strcmp("Add <LI>", (char*)client_data)==0)
		{
			buffer1 = "<LI>\t";
		  	buffer2 = "";
		}
	else if	(strcmp("Add <DT>, <DD>", (char*)client_data)==0)
		{
			buffer1 = "<DT>\t";
		  	buffer2 = "\n\t<DD>\t";
		}
/* Block tags */  		
	else if	(strcmp("Paragraph", (char*)client_data)==0)
		{
			buffer1 = "<P>\n";
		  	buffer2 = "";
		}
	else if	(strcmp("New Line", (char*)client_data)==0)
		{
			buffer1 = "<BR>";
		  	buffer2 = "";
		}	
	else if	(strcmp("Blockquote", (char*)client_data)==0)
		{
			buffer1 = "<Blockquote>";
		  	buffer2 = "</Blockquote>";
		}	
	else if	(strcmp("Preformatted", (char*)client_data)==0)
		{
			buffer1 = "<Pre>";
		  	buffer2 = "</Pre>";
		}	
	else if	(strcmp("Listing", (char*)client_data)==0)
		{
			buffer1 = "<Listing>";
		  	buffer2 = "</Listing>";
		}	
	else if	(strcmp("Address", (char*)client_data)==0)
		{
			buffer1 = "<Address>";
		  	buffer2 = "</Address>";
		}	
	else if	(strcmp("Horizontal Ruler", (char*)client_data)==0)
		{
			buffer1 = "<HR>\n";
		  	buffer2 = "";
		}	
	InsertTags(buffer1, buffer2);
}

